--
-- Mod: FS19_H_VereinfachteSteuerung_Event
--
-- Author: Hummel2211
-- email: 
-- @Date: 12.06.2019
-- @Version: 1.5.1.0

local myName = "FS19_H_VereinfachteSteuerung_Event"

-- #############################################################################

FS19_H_VereinfachteSteuerung_Event = {}
FS19_H_VereinfachteSteuerung_Event_mt = Class(FS19_H_VereinfachteSteuerung_Event, Event)
InitEventClass(FS19_H_VereinfachteSteuerung_Event, "FS19_H_VereinfachteSteuerung_Event")

-- #############################################################################

function FS19_H_VereinfachteSteuerung_Event:emptyNew()
  if debug > 2 then print("-> " .. myName .. ": emptyNew()") end

  local self = Event:new(FS19_H_VereinfachteSteuerung_Event_mt)
  self.className = "FS19_H_VereinfachteSteuerung_Event"
  return self
end

-- #############################################################################

function FS19_H_VereinfachteSteuerung_Event:new(vehicle, ...)
  local args = { ... }
  if debug > 1 then print("-> " .. myName .. ": new(): " .. lU:args_to_txt(unpack(args))) end

  local self = FS19_H_VereinfachteSteuerung_Event:emptyNew()
  self.vehicle = vehicle
  self.vehicle.vData.want = { unpack(args) }

  return self
end

-- #############################################################################

function FS19_H_VereinfachteSteuerung_Event:readStream(streamId, connection)
  if debug > 1 then print("-> " .. myName .. ": readStream() - " .. streamId) end

  self.vehicle               = NetworkUtil.readNodeObject(streamId);
  self.vehicle.vData.want[1] = streamReadBool(streamId);
  self.vehicle.vData.want[2] = streamReadBool(streamId);
  self.vehicle.vData.want[3] = streamReadInt8(streamId);
  self.vehicle.vData.want[4] = streamReadBool(streamId);
  self.vehicle.vData.want[5] = streamReadBool(streamId);
  self.vehicle.vData.want[6] = streamReadBool(streamId);

  if not connection:getIsServer() then
    g_server:broadcastEvent(FS19_H_VereinfachteSteuerung_Event:new(self.vehicle, unpack(self.vehicle.vData.want)), nil, connection)
  end

  if g_server == nil then
    self.vehicle.vData.is = { unpack(self.vehicle.vData.want) }
  end

  if debug > 1 then print("--> " .. self.vehicle.rootNode .. " - (" .. lU:args_to_txt(unpack(self.vehicle.vData.is)).."|"..lU:args_to_txt(unpack(self.vehicle.vData.want))..")") end
--  print(DebugUtil.printTableRecursively(self.vehicle.vData, 0, 0, 2))
end

-- #############################################################################

function FS19_H_VereinfachteSteuerung_Event:writeStream(streamId, connection)
  if debug > 1 then print("-> " .. myName .. ": writeStream() - " .. streamId) end

  NetworkUtil.writeNodeObject(streamId, self.vehicle);
  streamWriteBool(streamId, self.vehicle.vData.want[1])
  streamWriteBool(streamId, self.vehicle.vData.want[2])
  streamWriteInt8(streamId, self.vehicle.vData.want[3])
  streamWriteBool(streamId, self.vehicle.vData.want[4])
  streamWriteBool(streamId, self.vehicle.vData.want[5])
  streamWriteBool(streamId, self.vehicle.vData.want[6])
end

-- #############################################################################

function FS19_H_VereinfachteSteuerung_Event:sendEvent(vehicle, ...)
  local args = { ... }
  if debug > 1 then print("-> " .. myName .. ": sendEvent(): " .. lU:args_to_txt(unpack(args))) end

  if g_server ~= nil then
    if debug > 2 then print("--> g_server:broadcastEvent()") end
    g_server:broadcastEvent(FS19_H_VereinfachteSteuerung_Event:new(vehicle, unpack(args)), nil, nil, vehicle)
  else
    if debug > 2 then print("--> g_client:getServerConnection():sendEvent()") end
    g_client:getServerConnection():sendEvent(FS19_H_VereinfachteSteuerung_Event:new(vehicle, unpack(args)))
  end
end
